routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/prueba',function(){
	return view('user.home');
}); 

Route::get('/usuario',function(){
	return view('user.pages.user.show');
}); 
Route::get('/centro',function(){
	return view('user.pages.production.show');
}); 

Route::get('/editarc',function(){
	return view('user.pages.production.edit');
}); 

Route::get('/fc',function(){
	return view('user.pages.finance.create');
}); 

Route::get('/fe',function(){
	return view('user.pages.finance.edit');
}); 

Route::get('/fi',function(){
	return view('user.pages.finance.index');
}); 

Route::get('/fsm',function(){
	return view('user.pages.finance.showmonth');
}); 
Route::get('/fsy',function(){
	return view('user.pages.finance.showyear');
}); 


Route::get('/tc',function(){
	return view('user.pages.technical.create');
}); 

Route::get('/te',function(){
	return view('user.pages.technical.edit');
}); 

Route::get('/ti',function(){
	return view('user.pages.technical.index');
}); 

Route::get('/ts',function(){
	return view('user.pages.technical.show');
}); 





Route::get('/',function(){
	return view('auth.login');
}); 

Auth::routes(['verify'=>true]);

Route::group(['middleware'=>['auth','user:Encargado-Administrador'],'as' => 'user.'], function(){
	Route::get('/','HomeController@user_index')->name('inicio');

	Route::resource('responsable/finance','Responsable\FinanceController');
	Route::resource('responsable/production','Responsable\ProductionController');
	Route::resource('responsable/user','Responsable\UserController');
	Route::resource('responsable/technical','Responsable\TechnicalController');
	Route::post('responsable/upload_excel','Responsable\FinanceController@upload_excel')->name('finance.upload_excel');
	Route::post('responsable/technical/{technical}','Responsable\TechnicalconditionController@store')->name('technicalcondition.store');



});


Route::group(['middleware' => ['auth','user:Administrador'], 'as' => 'admin.'], function(){
	Route::get('/home','HomeController@index')->name('home');

	//Producione
	Route::resource('production','ProductionController');
	Route::get('production/{production}/update_all','ProductionController@update_all')->name('production.update_all');
	//Finance
	Route::get('finance/{production}/show_detail','FinanceController@show_detail')->name('finance.show_detail');
	Route::post('finance/upload_excel','FinanceController@upload_excel')->name('finance.upload_excel');
	Route::resource('finance','FinanceController');


	Route::resource('technical','TechnicalController');
	Route::get('technical/{technical}/downloadPDF','TechnicalController@downloadPDF')->name('technical.downloadPDF');

	Route::resource('technicalcondition','TechnicalconditionController');
	Route::post('technical/{technical}','TechnicalconditionController@store')->name('technicalcondition.store');


	Route::resource('event','EventController');
	//Period
	Route::resource('period','PeriodController');
	//user
	Route::resource('user','UserController');
	Route::get('user/{user}/assign_role','UserController@assign_role')->name('user.assign_role');
	Route::post('user/{user}/role_assignment','UserController@role_assignment')->name('user.role_assignment');
	Route::get('user/{user}/assign_permission','UserController@assign_permission')->name('user.assign_permission');
	Route::post('user/{user}/permission_assignment','UserController@permission_assignment')->name('user.permission_assignment');
	Route::post('user/{user}/update_all','UserController@update_all')->name('user.update_all');


	Route::resource('role','RoleController'); 
	Route::resource('permission','PermissionController');
});



Route::get('/clear-cache', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:cache');
    return "Cache is cleared";
});

app/Period.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Period extends Model
{
    protected $fillable = [
        'year','month','status','limiter',
    ];
    //Relaciones
    public function finances()
    {  
        return $this->hasMany('App\Finance');
    }

    //Almacenamiento 

    public function store($request){
        alert('Exito','El Periodo se ha guardado','success')->showConfirmButton();

        return Period::create($request->all());
    }

    public function my_update($request)
    {
        Period::update($request->all());
    }

    //Validaciones

    public function exists($period){

        if ($period->year==date('Y') && $period->month==date('n')) return true;
    }

    
    public static function current_period(){
        $active=Period::where('status',1)->first();
        return $active;
    }

    public function is_active($period){
        if ($period->status == 1 ) return true;
    }

    //Recuperación de información


    //Otras operaciones

    public static function change_status(){
        if (Period::where('status',1)->get()) {
            Period::where('status',1)->update(['status'=>0]);
        }
        
    }
    public static function limiter_period(){
        if (count(Period::where('status',1)->get())>0) {
            $period=Period::where('status',1)->first();
            if ($period->limiter < now()->toDateString()) {
                $period->update(['status'=>0]);
            }
        }
    }

}

app/Http/Controllers/PeriodController.php
<?php

namespace App\Http\Controllers;

use App\Period;
use App\Http\Requests\Period\StoreRequest;
use App\Http\Requests\Period\UpdateRequest;
use Illuminate\Http\Request;

class PeriodController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        Period::limiter_period();
        return view('admin.pages.period.index',[
            'periods' => Period::orderBy('id','DESC')->paginate(15),
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.pages.period.create');
     }   
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreRequest $request, Period $period)
    {
        Period::change_status();
        $period = $period->store($request);
        return redirect()->route('admin.period.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Period  $period
     * @return \Illuminate\Http\Response
     */
    public function show(Period $period)
    {

        return view('admin.pages.period.show',[
            'period' => $period,
            'finances' =>  $period->finances,
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Period  $period
     * @return \Illuminate\Http\Response
     */
    public function edit(Period $period)
    {
        return view('admin.pages.period.edit',[
            'period' => $period,
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Period  $period
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateRequest $request, Period $period)
    {
        Period::change_status();
        $period->my_update($request);
        return redirect()->route('admin.period.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Period  $period
     * @return \Illuminate\Http\Response
     */
    public function destroy(Period $period)
    {
        //
    }


}

resources/views/admin/pages/period/create.blade.php
@extends('admin.layouts.app')

@section('title','crear')

@section('header')


@endsection
@section('period')
active
@endsection
@section('content')


<section id="main-content">
	<section class="wrapper site-min-height">
		<div class="col-lg-12 mt">
            <div class="row content-panel">
              <div class="panel-heading w-100">
                <ul class="nav nav-tabs ">

                  <li class="">
                    <h4 >Registro nuevo  Periodo<h4/>
                  </li>
                </ul>
              </div>
              <!-- /panel-heading -->
              <div class="panel-body w-100">

                  <div id="registrar" class="">
                    <div class="col-12">
                        <form role="form"  class="form-horizontal" method="POST" action="{{ route('admin.period.store') }}" >
                        	@csrf

                        	<div class="col-lg-6 col-md-12  ">


	                          <div class="form-group">
	                            <label class="col-12"> Año</label>
	                            <div class="col-12">
	                              	<input id="year" type="number" class="form-control @error('year') is-invalid @enderror" name="year" value="{{ old('year') }}" required autocomplete="year" autofocus>

	                                @error('year')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>

	                          <div class="form-group">
	                            <label class="col-12"> Mes</label>
	                            <div class="col-12">
	                              	<input id="month" type="number" class="form-control @error('month') is-invalid @enderror" name="month" value="{{ old('month') }}" required autocomplete="month" autofocus>

	                                @error('month')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>

	                          <div class="form-group">
	                            <label class="col-12">Límite</label>
	                            <div class="col-12">
	                              	<input id="limiter" type="date" class="form-control @error('limiter') is-invalid @enderror" name="limiter" value="{{ old('limiter') }}" required autocomplete="limiter" autofocus>

	                                @error('limiter')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                          <div class="form-group">
	                            <label class="col-12">Estado</label>
	                            <div class="col-12">
	                              
	                              	<select name="status" class="form-control @error('status') is-invalid @enderror" required>
										
										<option value="1"> Activo</option>
								 		<option value="2"> Bloqueado</option>
										<option value="0"> Eliminado</option>

									</select>

	                                @error('status')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                        </div>  
	                        <div class="form-group">
	                            <div class="col-lg-offset-2 col-lg-10">
	                              <button class="btn btn-theme" type="submit">Guardar</button>
	                              <button class="btn btn-theme04" type="reset">Cancel</button>
	                            </div>
	                          </div>
                        </form>
                                         
                      <!-- /col-lg-8 -->
                    </div>
                    <!-- /row -->
                  </div>
                  <!-- /tab-pane -->
                </div>
                <!-- /tab-content -->
              </div>
              <!-- /panel-body -->
            </div>
            <!-- /col-lg-12 -->
          </div>

    </section>
</section>






	
	

@endsection

@section('footer')


@endsection

resources/views/admin/pages/period/edit.blade.php
@extends('admin.layouts.app')

@section('title','Editar'.$period->year.'-'.$period->month)

@section('header')


@endsection
@section('period')
active
@endsection
@section('content')


<section id="main-content">
	<section class="wrapper site-min-height">
		<div class="col-lg-12 mt">
            <div class="row content-panel">
              <div class="panel-heading w-100">
                <ul class="nav nav-tabs ">

                  <li class="">
                    <h4 >Editar Periodo {{ $period->year.'-'.$period->month }}<h4/>
                  </li>
                </ul>
              </div>
              <!-- /panel-heading -->
              <div class="panel-body w-100">

                  <div id="registrar" class="">
                    <div class="col-12">
                        <form role="form"  class="form-horizontal" method="POST" action="{{ route('admin.period.update',$period) }}" >
                        	@csrf
							{{ method_field('PUT') }}
                        	<div class="col-lg-6 col-md-12  ">


	                          <div class="form-group">
	                            <label class="col-12"> Año</label>
	                            <div class="col-12">
	                              	<input id="year" type="number" class="form-control @error('year') is-invalid @enderror" name="year" value="{{ $period->year }}" required autocomplete="year" autofocus>

	                                @error('year')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>

	                          <div class="form-group">
	                            <label class="col-12"> Mes</label>
	                            <div class="col-12">
	                              	<input id="month" type="number" class="form-control @error('month') is-invalid @enderror" name="month" value="{{ $period->month }}" required autocomplete="month" autofocus>

	                                @error('month')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>

	                          <div class="form-group">
	                            <label class="col-12">Límite</label>
	                            <div class="col-12">
	                              	<input id="limiter" type="date" class="form-control @error('limiter') is-invalid @enderror" name="limiter" value="{{ $period->limiter }}" required autocomplete="limiter" autofocus>

	                                @error('limiter')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                          <div class="form-group">
	                            <label class="col-12">Estado</label>
	                            <div class="col-12">
	                              
	                              	<select name="status" class="form-control @error('status') is-invalid @enderror" required>
										<option value="{{ $period->status }}" selected=""> 
											@if($period->status===0)
												Eliminado </option>
												<option value="1"> Activo</option>
										 		<option value="2"> Bloqueado</option>
											@elseif($period->status ===1)
												Activo </option>
												<option value="0"> Eliminado</option>
												<option value="2"> Bloqueado</option>
											@else
												Bloqueado</option>
												<option value="0"> Eliminado</option>
										 		<option value="1"> Activo</option>
											@endif
									</select>

	                                @error('status')
	                                    <span class="invalid-feedback" role="alert">
	                                        <strong>{{ $message }}</strong>
	                                    </span>
	                                @enderror
	                            </div>
	                          </div>
	                        </div>  
	                        <div class="form-group">
	                            <div class="col-lg-offset-2 col-lg-10">
	                              <button class="btn btn-theme" type="submit">Guardar</button>
	                              <button class="btn btn-theme04" type="reset">Cancel</button>
	                            </div>
	                          </div>
                        </form>
                                         
                      <!-- /col-lg-8 -->
                    </div>
                    <!-- /row -->
                  </div>
                  <!-- /tab-pane -->
                </div>
                <!-- /tab-content -->
              </div>
              <!-- /panel-body -->
            </div>
            <!-- /col-lg-12 -->
          </div>

    </section>
</section>






	
	

@endsection

@section('footer')


@endsection

resources/views/admin/pages/period/index.blade.php
@extends('admin.layouts.app')

@section('title','Periodos')

@section('header')


@endsection
@section('period')
active
@endsection
@section('content')

	<section id="main-content">
      <section class="wrapper">
        <!-- page start-->
        <div class="row mt">
          <div class="col-sm-3">
            <section class="panel">
              <div class="panel-body">
              		<a href="{{ route('admin.period.create')}}" disable="" class="btn btn-compose text-truncate">
                  		<i class="fa fa-pencil"></i>  Agregar Periodo
                	</a>
                <ul class="nav nav-pills nav-stacked mail-nav row">
                   <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2018
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2019
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2020
                  		<span class="label label-info pull-right inbox-notification">8</span>
                  	</a>
                  </li>
                </ul>
              </div>
            </section>
          </div>
          <div class="col-sm-9">
            <section class="panel">
              <header class="panel-heading wht-bg">
                <h4 class="gen-case">
                    Lista de Periodos
                    <form action="#" class="pull-right mail-src-position">
                      <div class="input-append">
                        <input type="text" class="form-control " placeholder="Search Mail">
                      </div>
                    </form>
                  </h4>
              </header>
              <div class="panel-body minimal">
         
                <div class="table-inbox-wrap ">
                  <table class="table table-inbox table-hover">
                    <tbody>
                    	@foreach($periods as $period)
                    	  <tr @if($period->status) class="unread" @endif >
	
              							<td class="inbox-small-cells">
              								<input type="checkbox" class="mail-checkbox">
              							</td>
              							<td class="view-message "><a href="{{ route('admin.period.show', $period) }}">{{ $period->year }}</a></td>
              							<td class="view-message "><a href="{{ route('admin.period.show', $period) }}">{{ $period->month }}</a></td>
              							<td class="view-message ">
              								<a href="{{ route('admin.period.show', $period) }}">
  			                    	@if($period->status===0 )
  			                    		<i class="fa fa-lock"></i> inactivo
  			                    	@elseif($period->status===1)
  			                    		<i class="fa fa-unlock"></i> activo 
  			                    	@endif	
              								</a>
            							</td>
            							
            							<td class="view-message ">
            								<a href="{{ route('admin.period.show', $period) }}" class="px-3">
            									{{ $period->limiter }}
            								</a>
            							</td>
                          <td class="view-message "><a href="{{ route('admin.period.edit', $period) }}" class="px-3"><i class="fa fa-pencil"></i></a></td>
            						</tr>
            					@endforeach
                    </tbody>
                  </table>
                </div>
              </div>
            </section>
          </div>
        </div>
      </section>
      <!-- /wrapper -->
    </section>



	
@endsection

@section('footer')


@endsection

resources/views/admin/pages/period/show.blade.php
@extends('admin.layouts.app')

@section('title','Perido')

@section('header')


@endsection
@section('period')
active
@endsection
@section('content')
	
	<section id="main-content">
      <section class="wrapper">
        <!-- page start-->
        <div class="row mt">
          <div class="col-sm-3">
            <section class="panel">
              <div class="panel-body">

              	<div lass="btn btn-theme text-truncate ">
              		 @if($period->exists($period))
                    Estás en el periodo actual
                   @endif
              	</div>

                <ul class="nav nav-pills nav-stacked mail-nav row">
                   <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2018
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2019
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2020
                  		<span class="label label-info pull-right inbox-notification">8</span>
                  	</a>
                  </li>
                </ul>
              </div>
            </section>
          </div>
          <div class="col-sm-9">
            <section class="panel">
              <header class="panel-heading wht-bg">
                <h4 class="gen-case">
                    Lista del periodo{{ $period->year.'-'.$period->month }}
                    <form action="#" class="pull-right mail-src-position">
                      <div class="input-append">
                        <input type="text" class="form-control " placeholder="Search Mail">
                      </div>
                    </form>
                  </h4>
              </header>
              <div class="panel-body minimal">
         
                <div class="table-inbox-wrap ">
                  <table class="table table-inbox table-hover">
                    <tbody>
                    	@foreach($finances as $finance)
	                     <tr>
          							<td class="inbox-small-cells">
          								<input type="checkbox" class="mail-checkbox">
          							</td>
          							<td class="view-message "><a href="{{ route('admin.finance.show', $finance) }}">{{ $finance->code }}</a></td>
          							<td class="view-message "><a href="{{ route('admin.finance.show', $finance) }}">{{ $finance->production->name }}</a></td>
          							<td class="view-message ">
          								<a href="{{ route('admin.finance.show', $finance) }}">S/ {{ $finance->quantity }}</a>
          							</td>
          							<td class="view-message ">
          								<a href="{{ route('admin.finance.show', $finance) }}">{{ $finance->observation }}</a>
          							</td>
          							<td class="view-message "><a href="{{ route('admin.finance.show', $finance) }}" class="px-3"><i class="fa fa-pencil"></i></a></td>
          							<td class="view-message  text-right">
          								<a href="{{ route('admin.finance.show', $finance) }}" class="px-3">
          									{{ $finance->date }}
          								</a>
          							</td>
          							<td class="view-message  text-right">
          								<a href="{{ route('admin.finance.show', $finance) }}" class="px-3">
          									{{ $finance->updated_at }}
          								</a>
          							</td>
          						</tr>
          						@endforeach
                    </tbody>
                  </table>
                </div>
              </div>
            </section>
          </div>
        </div>
      </section>
      <!-- /wrapper -->
    </section>

	
@endsection

@section('footer')


@endsection